/*
    SequcnerSerial.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
#ifndef SequencerSerial_H
#define SequencerSerial_H

#include "Sequencer/Sequencer.h"
#include "TimedSerial.h"

using namespace std;

//adaptor TimedSerial to Sequencer
class SequencerSerial:public Sequencer
{
protected:
  static const int ctrlRate = 100;//100$B$H$$$&?t;z<+BN$K$O0UL#$,L5$$!#(B
  TimedSerial* timedSerial;
  
  virtual uchar checkChannel (uchar channel);
  void sendAllChannel (uchar data[3]);
public:
  SequencerSerial (State* globalState, Option* option__);//constructor
  virtual ~SequencerSerial ();//destructor
  
  virtual void dumpBuf ();
  virtual void allNoteOffSoundOff ();
  virtual void reset ();
  
  //midi event$B$r<B9T$9$k!#(B
  virtual void noteOff (uchar channel, uchar note, uchar velocity);
  virtual void noteOn (uchar channel, uchar note, uchar velocity);
  virtual void polyphonicKeyPressure (uchar channel,
				      uchar note, uchar keyPressure);
  virtual void controlChange (uchar channel, uchar control, uchar value);
  virtual void programChange (uchar channel, uchar  program);
  virtual void channelPressure (uchar channel, uchar channelPressure);
  virtual void pitchBendChange (uchar channel, uchar lsb, uchar msb);
  virtual void exclusive (const uchar* udata, uint32 size, int channel = -1);
  virtual void portChange (int port);
  virtual int getCtrlRate () throw (Error);
  virtual void waitTimer (ulong ticks);
  virtual void deltaTime (ulong ticks);
  virtual void startTimer ();
  virtual void stopTimer ();
  virtual void sync ();
};
#endif// SequencerSerial_H
