/*
    SongCommand.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#include "SongCommand.h"

SongCommand::SongCommand ():
  sysExData (NULL), muting (NULL)
{
  reset ();
}

SongCommand::SongCommand (const SongCommand& songCommand_):
  sysExData (NULL), muting (NULL)
{
  command = songCommand_.command;
  position = songCommand_.position;
  skew = songCommand_.skew;
  memcpy (midiParameter, songCommand_.midiParameter,
	  sizeof (midiParameter));
  sysExSize = songCommand_.sysExSize;
  if (sysExSize > 0)
    {
      sysExData = new uchar[sysExSize];
      memcpy (sysExData,songCommand_.sysExData, sysExSize);
    }
  muteSize = songCommand_.muteSize;
  if (muteSize > 0)
    {
      assert (songCommand_.muting != NULL);
      muting = Sequencer::Muting::newCopy (songCommand_.muting, muteSize);
    }
}


SongCommand::~SongCommand ()
{
  delete[] sysExData;
  delete[] muting;
}
