/*
    State.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "util/onceUtil.h"
#include "State.h"

const int State::MAX_PARTS;


/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////thread stuff
/////////////////////////////////////////////////////////////////////////
State::State ():
  mutexLock (),hasBeenChanged (),songStatus ()
{
  partReset ();
}

State::~State ()
{
  //do nothing
}


void State::reset () throw (Error)
{
  songStatus.reset ();
  partReset ();
  sequencerStatus.reset ();
}

void State::fullReset () throw (Error)
{
  songStatus.fullReset ();
  partReset ();
  sequencerStatus.reset ();
}

void State::partReset () throw (Error)
{
  for (int i=0;i<MIDI::MAX_CHANNEL;i++)
    {
      //prot A
      part[i].reset(i,SequencerStatus::PORT_A);
      //port B
      part[i+MIDI::MAX_CHANNEL].reset (i,SequencerStatus::PORT_B);
    }
  
}
