#ifndef PThreadStartRoutine_H
#define PThreadStartRoutine_H

#include <cassert>

#include "util/mytype.h"

using namespace std;

template<typename T, void (T::*startRoutine) ()>
void* PThreadStartRoutine (void* me)
{
  DEBUG_MESSAGE ("PThreadStartRoutine called");
  assert (me != NULL);
  assert (startRoutine != NULL);
  DEBUG_MESSAGE ("PThreadStartRoutine calling method");
  (static_cast<T*>(me)->*startRoutine) ();
  return NULL;
};

#endif // PThreadStartRoutine_H
